/**
 * remote.js
 * Copyright (c) 2000 - 2015 Samsung Electronics Co., Ltd. All rights reserved.
 *
 * Contact:
 * DongHee Yang <donghee.yang@samsung.com>
 * Sungmin Kim <sm.art.kim@samsung.com>
 * Jiil Hyoun <jiil.hyoun@samsung.com>
 * Jonghwan Park <iwin100.park@samsung.com>
 * Kitae Kim <kt920.kim@samsung.com>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Contributors:
 * - S-Core Co., Ltd
**/

var dibs = require('../../core/dibs');

// callback(err, approvalId)
module.exports.addApproval = function (email, subject, contents, summary, routes, type, callback) {
    dibs.thisServer.addApprovalInternal(email, subject, contents, summary, routes, type, callback);
};

// callback(error, approvals)
module.exports.searchApprovals = function (queryObject, callback) {
    dibs.thisServer.searchApprovalsInternal(queryObject, callback);
};


// callback(err, approval)
module.exports.getApproval = function (approvalId, callback) {
    dibs.thisServer.getApprovalInternal(approvalId, callback);
};


// calllback(err)
module.exports.modifyApproval = function (approval, evnetType, callback) {
    dibs.thisServer.modifyApprovalInternal(approval, evnetType, callback);
};


// calllback(err)
module.exports.approve = function (approvalId, email, message, callback) {
    dibs.thisServer.approveInternal(approvalId, email, message, callback);
};

// calllback(err)
module.exports.reject = function (approvalId, email, message, callback) {
    dibs.thisServer.rejectInternal(approvalId, email, message, callback);
};


// calllback(err)
module.exports.cancel = function (approvalId, email, message, callback) {
    dibs.thisServer.cancelInternal(approvalId, email, message, callback);
};
